<template>
    <v-card-text>
        <v-alert v-if="err != ''" dense text type="error">
            {{err}}
        </v-alert>
        <v-alert v-if="ok != ''" dense text type="success">
            {{success}}
        </v-alert>
        <v-form ref='form' v-model="valid">
            <v-text-field label="Username"
                          name="Username"
                          :counter="16"
                          :rules="userRules"
                          v-model="user"
                          prepend-icon="mdi-account"
                          required
                          type="text"/>

            <v-text-field
                    id="password"
                    v-model="password"
                    label="Password"
                    :rules="passwordRules"
                    name="password"
                    required
                    prepend-icon="mdi-lock"
                    type="password"
            />
        </v-form>
        <v-card-actions>
            <v-spacer/>
            <v-btn color="primary"
                   @click="Clear">
                Clear
            </v-btn>
            <v-btn color="primary"
                   :disabled="!valid"
                   @click="Register">
                Register
            </v-btn>
        </v-card-actions>
    </v-card-text>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
    import {Component} from 'vue-property-decorator';
    import {Mixins} from "vue-mixin-decorator";
    import {Validable} from "../mixins/Validable";
    import {auth} from "../init";


    @Component
    export default class RegisterComponent extends Mixins<Validable>(Validable) {
        valid: boolean = true;
        user: string = "";
        password: string = "";

        userRules = [
            v => !!v || 'Username is required',
            v => (v && v.length >= 5) || 'Username must be at least 5 characters long',
            v => (v && v.length <= 16) || 'Username cannot exceed 16 characters long',
        ]

        passwordRules = [
            v => !!v || 'Password is required',
            v => (v && v.length >= 8) || 'Password must be at least 8 characters long',
            v => (v && v.length <= 256) || 'Password cannot exceed at least 256 characters long',
        ]


        get Form(): any {
            return this.$refs['form'];
        }

        async Register() {
            const valid = this.Form.validate();
            if (valid) {
                const s = await auth.signup(this.user, this.password);
                if (s != "") {
                    this.err = s;
                } else {
                    this.ok = "Successfully created account!";
                }
            } else {
                this.password = "";
            }
        }

        Clear() {
            this.Form.reset();
        }
    }
</script>
